<template>
  <a-tooltip :content="props.tooltip" :position="position">
    <a-button
      :style="`width: ${outsize}px;height: ${outsize}px`"
      :loading="loading"
      :disabled="disabled"
      :type="btnType"
      :status="btnStatus"
      :shape="shape"
      @click="emits('goto')"
    >
      <template #icon>
        <icon />
      </template>
    </a-button>
  </a-tooltip>
</template>

<script setup lang="ts">
import { UNDEFINED } from '@arco-vue-x/utils'
import { h, computed } from 'vue'
import { DEFAULT_VALUE, TYPE_MATCH, IType, IShape } from './help'

const emits = defineEmits(['goto'])

const props = withDefaults(
  defineProps<
    Partial<{
      size: number;
      status?: 'normal' | 'success' | 'warning' | 'danger' | undefined;
      isBold?: boolean;
      tooltip?: string;
      content?: string;
      disabled: boolean;
      type: IType;
      loading: boolean;
      shape: IShape;
      outsize: number;
      position?:
        | 'top'
        | 'tl'
        | 'tr'
        | 'bottom'
        | 'bl'
        | 'br'
        | 'left'
        | 'lt'
        | 'lb'
        | 'right'
        | 'rt'
        | 'rb';
      btnType: 'primary' | 'secondary' | 'dashed' | 'outline' | 'text';
    }>
  >(),
  {
    position: 'top'
  }
)

const btnStatus = computed(
  () => props.status ?? (props.type === 'delete' ? 'danger' : 'normal')
)

const icon = () => {
  const { size, isBold, type } = props
  return h(TYPE_MATCH[type as IType]?.icon, {
    size,
    strokeWidth: isBold ? DEFAULT_VALUE.strokeWidth : UNDEFINED
  })
}
</script>

<style lang="less" scoped>
.templateIcon {
  stroke-width: 5;
  &.f18 {
    font-size: 18px;
  }
}
</style>
